# -*- coding: utf-8 -*-
from bpnn import *
import random
# bpnn.py has been dowloaded from http://python.ca/nas/python/
# there we can find also other programs of Neil Schemenauer, as
# explained at http://python.ca/nas/ (tnx to Neil)

# reader (similar to readMyFile.py

def findmin(lis):
    minv=lis[0]
    for i in range(len(lis)):
            if lis[i]<minv:
                minv=lis[i]
    return minv        


def findmax(lis):
    maxv=lis[0]
    for i in range(len(lis)):
            if lis[i]>maxv:
                maxv=lis[i]
    return maxv        

def readDatalist(fileName):
 temp=[]
 v=[]
 r=0

 f=open(fileName,"r")        

 for line in f:
     line=line.replace(","," ")
     temp.append(line.split())
 f.close()

 while temp != []:
     item=temp.pop(0)
     r=r+1
     while item != []: #empty line case fixed here
         v.append(float(item.pop(0)))

 # list
 
 l=[]
 for i in range(r):
     l.append(v[i])
 return l

        
def readDataM(fileName,c1,c2):
 temp=[]
 v=[]
 r=0

 f=open(fileName,"r")        

 for line in f:
     line=line.replace(","," ")
     temp.append(line.split())
 f.close()

 while temp != []:
     item=temp.pop(0)
     r=r+1
     while item != []: #empty line case fixed here
         v.append(float(item.pop(0)))

 c=c1+c2

 # matrix in plain Python
 m=[]
 for i in range(r):
     m.append([[0]*c1,[0]*c2])

 for i in range(r):
     for j in range(c1):
         m[i][0][j]=v[c*i+j]
 for i in range(r):
     for j in range(c2):
         m[i][1][j]=v[c*i+j+c1]
 return m

def createpat(f,ndat,mem,ch,co): #create pattern from time series
    ts=readDatalist(f)

    # pattern matrix: mem input e 1 output

    pat=[]
    for i in range(ndat):
        pat.append([[0]*mem,[0]])
        ran=random.randint(0,len(ts)-(mem+1))
        for j in range(mem):
            pat[i][0][j]=ts[ran+j]
        for j in range(co):
            pat[i][1][j]=ts[ran+j+mem]

    patscaled=[]
    for i in range(ndat):
        patscaled.append([[0]*mem,[0]*co])
        for j in range(mem):    
            patscaled[i][0][j]=pat[i][0][j]/(2*pat[i][0][0])
        for j in range(co):
            patscaled[i][1][j]=pat[i][1][j]/(2*pat[i][0][0])
    
    results=patscaled
    return results


def createNN(mem,ch,co,pat,name):

   # create a neural network with mem input, h hidden, and co output
    n = NN(mem, ch, co)
    # train it with some patterns
    n.train(pat, iterations = 10000)

    fout=open('wi'+name+'.out','w')

    for i in range(mem+1):
        for j in range(ch):
            fout.write('%f '%n.wi[i][j])
        fout.write('\n')
    
    fout.close()

    fout=open('wo'+name+'.out','w')

    for i in range(ch):
        line=''
        for j in range(co):
            fout.write('%f ' %n.wo[i][j])
        fout.write('\n')    
    
    fout.close()

    return n

#running program

f= "fiat.txt"
ndat=1000 #number of patterns
ch=4   #hidden layers
co=1   # number of output (it is 1, but there can be generalizations)
mem=5  #number of inputs
nNN=90  #n of NN to be created

for i in range(58,nNN):
    name='%d' %i
    print name
    pat=createpat(f,ndat,mem,ch,co)
    createNN(mem,ch,co,pat,name)
